#include <iostream>
#include <fstream>
#include <utility>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <cctype>
using namespace std;

int count_numbers(const char *x) {
    int back = 0;
    while(x[1]) {
	if(isdigit(x[1]) && !isdigit(x[0]))
	    back++;
	x++;
    }
    return back;
}

void output(const char *&form) {
    for(;;) {
	if(isspace(*form)) {
	    form++; continue;
	}
	if(*form == '(')
	    cout << *form++;
	else
	    break;
    }
    while(isspace(*form))
	form++;
    for(;;) {
	if(isdigit(*form))
	    cout << *form++;
	else
	    break;
    }
    while(isspace(*form))
	form++;
    for(;;) {
	if(isspace(*form)) {
	    form++; continue;
	}
	if(*form == ')')
	    cout << *form++;
	else
	    break;
    }
}

long parseInt(const char *&form) {
    long val = 0;
    while(isspace(*form)) form++;
    while(isdigit(*form)) {
	val = val * 10 + (*form - '0');
	form++;
    }
    //    cout << val << "; " << form << endl;
    return val;
}

long evalOp(long val1, long val2, int op) {
    if(op == 0) return val1+val2;
    if(op == 1) return val1-val2;
    return val1*val2;
}

long ops;

long eval(const char *&form) {
    long val = 0;
    bool first = true;
    while(*form != ')') {
	// cout << "*" << *form << flush;
	if(isdigit(*form)) {
	    if(first) {
		first = false;
		val = parseInt(form);
	    } else {
		long nextVal = parseInt(form);
		val = evalOp(val, nextVal, ops % 3);
		ops /= 3;
	    }
	} else if(*form == '(') {
	    ++form;
	    if(first) {
		first = false;
		val = eval(form);
	    } else {
		long op = ops % 3;
		ops /= 3;
		long nextVal = eval(form);
		val = evalOp(val, nextVal, op);
	    }
	} else {
	    ++form; // whitespace
	}
    }
    ++form;
    //    cerr << "REST: " << form << endl;
    return val;
}

int main(int, char **) {
    ifstream in("dreisam.in");
    int no = 1;
    for(;;) {
	long result;
	in >> result;
	if(result == 0)
	    return 0;

	cout << "Equation #" << no++ << endl;
	char c;
	do {
	    in >> c;
	} while(c != '=');

	char formula[1000];
	string f;
	getline(in, f);
	f += ')';
	strcpy(formula, f.c_str());
	// cout << "XXX" << endl;
	// cout << f << endl;

	int length = count_numbers(formula);

	//	cout << "XXX" << endl;
	long anz = (long) pow(3, length - 1);
	long i;
	for(i = 0; i < anz; i++) {
	    //  cout << i << flush;
	    const char *x = f.c_str();
	    ops = i;
	    if(eval(x) == result)
		break;
	}

	f[f.size()-1] = ' ';
	if(i != anz) {
	    long ok = i;
	    cout << result << "=";
	    const char *g = f.c_str();
	    output(g);
	    char operators[] = "+-*";
	    for(int i = 0; i < length - 1; i++) {
		cout << operators[ok % 3];
		ok /= 3;
		output(g);
	    }
	} else {
	    cout << "Impossible";
	}
	cout << endl << endl;
    }
}
