#include <iostream>
#include <fstream>
#include <utility>
#include <algorithm>
#include <vector>
#include <string>
using namespace std;

int w, h;
vector<int> xup, yup;
int di;
vector<vector<int> > dist;
vector<string> map;
int endx, endy;

int access(int x, int y) {
    cout << "*" << x << y;
   
    if(x == endx && y == endy)
	return 1;
    if(map[y][x] != ' ')
	return -1;
    if(dist[y][x] > di) {
	//	cout << "OK" << endl;
	dist[y][x] = di;
	xup.push_back(x);
	yup.push_back(y);
    }
    //  cout << endl;
    cout << "OK";
    return 0;
}

bool go(int x, int y, int xd, int yd) {
    for(;;) {
	x += xd; y+= yd;
	if(!(x >= 0 && y >= 0 && x < w + 2 && y < h + 2))
	    return false;
	int acc = access(x,y);
	if(acc == -1)
	    return false;
	if(acc == 1)
	    return true;
    }
}

bool explore(int x, int y) {
    return go(x,y,-1,0) || go(x,y,1,0) || go(x,y,0,-1) || go(x,y,0,1);
}

int f(int startx, int starty) {
    //cout << startx << " " << starty << endl;
    //    for(int i = 0; i < h + 2; i++)
    //	cout << map[i] << endl;
    xup.clear();
    yup.clear();
    xup.push_back(startx);
    yup.push_back(starty);
    di = 0;
    while(!xup.empty()) {
	++di;
	// cout << di << " " << flush;
	vector<int> xold, yold;
	xold = xup;
	yold = yup;
	xup.clear();
	yup.clear();
	for(int i = 0; i < xold.size(); i++)
	    if(explore(xold[i], yold[i]))
		return di;
    }
    return -1;
}

int main(int, char **) {
    ifstream in("game.in");
    int no = 1;
    for(;;) {
	string s;
	in >> w >> h; getline(in, s);
	if(w == 0)
	    return 0;
	cout << "Board #" << no++ << ":" << endl;

	s = "";
	for(int i = 0; i < w + 2; i++)
	    s += ' ';
	map.clear();
	map.push_back(s);
	for(int i = 0; i < h; i++) {
	    string t;
	    getline(in, t);
	    map.push_back(" " + t + s);
	}
	map.push_back(s);

	vector<int> d;
	d.resize(w + 2, 10000);
	dist.clear();
	for(int i = 0; i < h+2; i++)
	    dist.push_back(d);

	int pair = 1;
	for(;;) {
	    int startx, starty;
	    in >> startx >> starty >> endx >> endy;
	    if(endx == 0)
		break;
	    cout << "Pair " << pair++ << ": " << flush;

	    int val = f(startx, starty);
	    if(val == -1) cout << "impossible.";
	    else cout << val << " segments.";
	    cout << endl;
	}
	
	cout << endl;
    }
}


