#include <iostream>
#include <fstream>
#include <utility>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <cctype>
using namespace std;

int **maze;
int w,h;

int countCycle( int y, int x ) {
    if (x>=0 && x<2*w && y>=0 && y<2*h ) {
	if (maze[y][x] == ' ' ) {
	    maze[y][x] = '.';
	    if ( y%2 == 0 ) {
		if ( x%2 == 0 ) {
		    return 1+
			countCycle( y-1, x ) +
			countCycle( y-1, x+1) +
			countCycle( y, x-1 ) +
			countCycle( y+1,x-1);
		} else {
		    return 1+
			countCycle( y, x+1 ) +
			countCycle( y-1, x-1) +
			countCycle( y+1, x+1) +
			countCycle( y-1, x );
		}
	    } else {
		if ( x%2 == 0 ) {
		    return 1+
			countCycle( y+1, x ) +
			countCycle( y-1, x-1) +
			countCycle( y+1,x+1) +
			countCycle( y, x-1 );
		} else {
		    return 1+
			countCycle( y+1, x ) +
			countCycle( y+1, x-1) +
			countCycle( y-1, x+1) +
			countCycle( y, x+1 );
		}
	    }
	} else {
	    return 0;
	}
    } else 
	return -10000;
}

int main(int, char **) {
    ifstream in("maze.in");

    int no = 1;
    for(;;) {

	in >> w >> h;
	if ( w==0 && h == 0) break;
	
	maze = new int*[2*h];
	for(int i = 0; i < 2*h; i++)
	    maze[i] = new int[2*w];

	for (int i=0; i<2*h; i++ )
	    for (int j=0; j<2*w; j++ )
		maze[i][j] = ' ';

	char c;

	string s;
	for (int i=0; i<h; i++ ) {
	    getline(in, s);
	    for (int j=0; j<w; j++ ) {
		in >> c;
		if ( c== '\\' ) {
		    maze[2*i][2*j] = '\\';
		    maze[2*i+1][2*j+1] = '\\';
		}else {
		    maze[2*i+1][2*j] = '/';
		    maze[2*i][2*j+1] = '/';
		}
	    }
	}

	int maxc = -1;
	int cycle = 0;

	for (int i=0; i<2*h; i++ ) {
	    for (int j=0; j<2*w; j++ ) {
		if (maze[i][j] == ' ' ) {
		    int cc = countCycle( i,j );
		    if(cc > 1) {
			if (cc>maxc) {
			    maxc = cc;
			}
			if ( cc>0 ) cycle++;
		    }
		}
	    }
	}
	cout << "Maze #" << no++ << ":" << endl;
	if(cycle)
	    cout << cycle << " Cycles; the longest has length " << maxc << "." << endl;
	else
	    cout << "There are no cycles." << endl;
	cout << endl;

	for(int i = 0; i < 2*h; i++)
	    delete[] maze[i];
	delete[] maze;

    }
}
